/* @(#) $Id: client.h 1526 2019-07-18 03:35:24Z leres $ (LBL) */
#ifndef acld_client_h
#define acld_client_h

#include "io.h"

enum clienttype {
	CTYPE_PRIV = 0,			/* unlimited */
	CTYPE_RO,			/* read/only */
	CTYPE_WEB			/* permittcpdsthostport */
};

struct client {
	struct client *next;
	u_int n;			/* client number */
	int c;				/* client socket */
	struct addr addr;		/* client ip address */
	enum clienttype type;
	time_t connect_ts;		/* connection timestamp */
	int close;			/* finish writing and then close */
	int replicant;			/* are we a replicant? */
	struct iobuf rbuf;		/* read buffer */
	struct iobuf wbuf;		/* write buffer */
	struct req *treq;		/* partially built request */
	struct req *req;		/* request list */
	struct req *hreq;		/* handleclientreqs() temp req list */
};

extern struct s2v cmd2req[];
extern struct s2v ctype2str[];

extern void clientcompact(struct state *, struct client *, struct req *);
extern void clientdroprestore(struct state *, struct client *, struct req *);
extern void clientfinishreq(struct state *, struct client *, struct req *);
extern void clientinput(struct state *, struct client *);
extern void clientlistroute(struct state *, struct client *, struct req *, int);
extern void clientnullzero(struct state *, struct client *, struct req *);
extern void clientprefix(struct state *, struct client *, struct req *);
extern void clientprocess(struct state *, struct client *, struct req *, int);
extern void clientquerynullzero(struct state *, struct client *, struct req *);
extern void clientsend(struct client *, struct req *);
extern void clientsendall(struct state *);
extern void clientsenderr(struct client *, struct req *, const char *, ...)
    __attribute__ ((format (printf, 3, 4)));
extern void clientsendallerr(struct state *, const char *, ...)
    __attribute__ ((format (printf, 2, 3)));
extern void clientsendfmt(struct client *, struct req *, const char *, ...)
    __attribute__ ((format (printf, 3, 4)));
extern void clientwhitelist(struct state *, struct client *, struct req *);
extern void clientwrite(struct client *, const char *);
extern void freeclient(struct state *, struct client *);
extern struct client *newclient(struct state *, int);
#endif
